require "gitfave/version"
require "gitfave/client"

module Gitfave

	class Main
		attr_accessor :username, :client

		def initialize(username)
			@username = username
			@client = Client.new(@username)
		end

		def language_count
			all_repo_languages = @client.user_repositories.map {|repo| repo["language"]}
			languages_used = all_repo_languages.uniq
			languages_used.each.map {|language| {:language => language, :count => all_repo_languages.count(language)}}
		end

		def users_favourite_language
			most_popular_count = 0
			most_popular_language = nil
			language_count.each do |lc|
				if lc[:count] > most_popular_count
					most_popular_language = lc
					most_popular_count = lc[:count]
				end
			end

			return most_popular_language
		end

		def print_favourite_language
			favourite = users_favourite_language
			"#{@username}'s favourite language is #{favourite[:language]}, having used it #{favourite[:count]} time(s)"
		end
	end
end
